<?php
// $Id: og_entitlements.admin.inc,v 1.1.2.1 2010/12/09 17:32:05 erikwebb Exp $

/**
 * @file
 * Administration forms and functions for the og_entitlements module.
 */

function og_entitlements_admin_form($form_id) {
  require_once(drupal_get_path('module', 'entitlements') .'/entitlements.inc');

  $form = array();
  $groups = _og_entitlements_get_groups();
  $groups[0] = '';
  asort($groups, SORT_STRING);
  $group_selects = array();

  $result = db_query('SELECT DISTINCT eid, title FROM {entitlements} ORDER BY title ASC');

  while ($row = db_fetch_object($result)) {
    $entitlement = _entitlements_load($row->eid);

    $form['entitlement_' . $entitlement->eid] = array(
      '#type' => 'select',
      '#title' => $entitlement->title . ' (' . $entitlement->eid . ')',
      '#default_value' => $entitlement->group,
      '#name' => 'entitlement_' . $entitlement->eid,
      '#id' => 'entitlement_' . $entitlement->eid,
      '#options' => $groups,
    );
  }

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );

  return $form;
}

function og_entitlements_admin_form_submit($form, &$form_state) {
  $entitlements_values = array();

  $matches = array();
  foreach ($form_state['values'] as $key => $value) {
    if (preg_match('/entitlement_([A-Za-z0-9]+)/', $key, $matches)) {
      $entitlements_values[$matches[1]] = $value;
    }
  }

  // reset entire table because submitted form represents all rows
  db_query('TRUNCATE {entitlements_og}');

  $entitlement = new stdClass();
  foreach ($entitlements_values as $eid => $nid) {
    $entitlement->eid = $eid;
    $entitlement->nid = $nid;
    drupal_write_record('entitlements_og', $entitlement);
  }

  drupal_set_message('Mappings successfully saved.');
}
